<?php
/**
* Joomla Community Builder User Plugin: plug_cbhelloworld
* @version $Id$
* @package plug_simplesort
* @author Mikko
* @copyright (C) www.mikkosoft.fi
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL

*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );


$_PLUGINS->registerFunction( 'onStartUsersList','doSort','simpleSort');
$_PLUGINS->registerFunction( 'onBeforeDisplayUsersList','addSortToCols','simpleSort'); 

class simpleSort extends cbPluginHandler{
	
	function doSort($listid, $row, $search, $limitstart, $limit, $ui){
		global $mainframe, $_CB_database,$mosConfig_debug;
		
			
		$sortcol=(int)mosGetParam($_GET,"sortcol",-1);
		$sortdir=(int)mosGetParam($_GET,"sortdir",-1);

		if($sortcol!=-1&&$sortdir!=-1){
			if($mosConfig_debug)

			echo "<p>Found sort data in request</p>";
			
			if (!isset( $_SESSION['session_userstate'] )){
				$_SESSION['session_userstate']=array();
			}	

			$mainframe->setUserState("sort$listid",array($sortcol,$sortdir));
		}

		$sort=$mainframe->getUserState("sort$listid");
		
		if($sort!=null){
			if($mosConfig_debug)
					echo "<p>Found sort data in session</p>";

			$temp="col".$sort[0]."enabled";
			if($row->$temp){
				$temp="col".$sort[0]."fields";
				$temp=$row->$temp;
				$fieldids=explode(",",$temp);
				$fieldid=$fieldids[0];
				$_CB_database->setQuery("SELECT name FROM #__comprofiler_fields WHERE fieldid = $fieldid");
				$field=	$_CB_database->loadResult();

				$row->sortfields=$field." ".($sort[1]?"DESC":"ASC");
				if($mosConfig_debug)
					echo "<p>Set sort fields to $row->sortfields </p>";
			}
		}
	}
	function addSortToCols($row, $users, $columns, $allFields, $lists, $listid, $search, $option_itemid, $ui){
		global $mainframe, $mosConfig_live_site;
		$ue_base_url			= "index.php?option=com_comprofiler&amp;task=usersList&amp;listid=" . $listid . $option_itemid; // . $spoofAmp;	// Base URL string

		$imgpath=$mosConfig_live_site."/components/com_comprofiler/plugin/user/plug_cbsimplesort";
		
		$sort=$mainframe->getUserState("sort$listid");
		$sortcol=null;
		$sortdir=null;
		if($sort!=null){
			$sortcol=$sort[0];
			$sortdir=$sort[1];
		}
		
		foreach($columns as $colid=>$column){
			$colid++;
			$column->title=getLangDefinition( $column->title)." ".
				($sortcol==$colid&&$sortdir==0?"<img src=\"$imgpath/uparrow-1.png\">":"<a href=\"$ue_base_url&sortcol=$colid&sortdir=0\"><img src=\"$imgpath/uparrow.png\"></a> ").
				($sortcol==$colid&&$sortdir==1?"<img src=\"$imgpath/downarrow-1.png\">":"<a href=\"$ue_base_url&sortcol=$colid&sortdir=1\"><img src=\"$imgpath/downarrow.png\"></a> ");
				
		}
	}
}